#ifndef LIDAR_TRACKER_TRACK_H_
#define LIDAR_TRACKER_TRACK_H_

#include <stdint.h>

#include <deque>
#include <memory>

#include "box2d.h"
#include "estimator.h"
// #include "lidar_tracker.pb.h"
#include "types.h"

namespace lidar_tracker {

struct TrackState {
  uint32_t id;
  double timestamp;
  ObservationType type;
  Box2d bounding_box;
  TrackLifeState life_state = TrackLifeState::TLS_IDLE;
  Estimator estimator;
  std::shared_ptr<const ObservationProto> observation = nullptr;
};

struct Track {
  TrackState track_state;
  std::deque<TrackState> checkpoints;
};

using TrackPtr = std::shared_ptr<Track>;

}  // namespace lidar_tracker

#endif  // LIDAR_TRACKER_TRACK_H_
